TIP(1) | General Commands Manual | TIP(1)

# NAME

`tip`, `cu` —
serial terminal emulator

# SYNOPSIS

`tip` | [`-v`] `-`speed system-name

`tip` | [`-v`] `-`speed phone-number

`cu` | [options] phone-number

`cu` | [options] “dir”

`cu` | `--help`

# DESCRIPTION

`tip` and `cu` are used to connect to another system over a serial link. In the era before modern networks, they were typically used to connect to a modem in order to dial in to a remote host. They are now frequently used for tasks such as attaching to the serial console of another machine for administrative or debugging purposes.

The following option is available for `tip`:

`-v`
  Set verbose mode.

The following options are available for `cu`:

`-a` acu
  Set the ACU port.
`-c` number
  Call this number.
`-E` char
  Use this escape character.
`-e`
  Use even parity.
`-F` flow
  Set flow control to hard, soft, or none.
`-f`
  Use no flow control.
`-h`
  Echo characters locally (half-duplex mode).
`-l` line
  Specify the line to use. Either of the forms like tty00 or /dev/tty00 are permitted.
`-n`
  No escape (disable tilde).
`-o`
  Use odd parity.
`-P` parity
  Set parity to even or odd.
`-p` acu
  Set the ACU port.
`-s` speed
  Set the speed of the connection. Defaults to 9600.
`-t`
  Connect via a hard-wired connection to a host on a dial-up line.

For `cu`, if both `-e` and `-o` are given, then no parity is used. This is the default behaviour.

If speed is specified it will override any baudrate specified in the system description being used.

If neither speed nor system-name are specified, system-name will be set to the value of the `HOST` environment variable.

If speed is specified but system-name is not, system-name will be set to a value of “tip” with speed appended. e.g. `tip -1200` will set system-name to “tip1200”.

Typed characters are normally transmitted directly to the remote machine (which does the echoing as well). A tilde (`~') appearing as the first character of a line is an escape signal; the following are recognized:

`~^D` or `~`.
  Drop the connection and exit (you may still be logged in on the remote machine).
`~c` [name]
  Change directory to name (no argument implies change to your home directory).
`~!`
  Escape to a shell (exiting the shell will return you to tip).
`~>`
  Copy file from local to remote. `tip` prompts for the name of a local file to transmit.
`~<`
  Copy file from remote to local. `tip` prompts first for the name of the file to be sent, then for a command to be executed on the remote machine.
`~p` from [to]
  Send a file to a remote UNIX host. The put command causes the remote UNIX system to run the command string ``cat > 'to''', while `tip` sends it the ``from'' file. If the ``to'' file isn't specified the ``from'' file name is used. This command is actually a UNIX specific version of the ``~>'' command.
`~t` from [to]
  Take a file from a remote UNIX host. As in the put command the ``to'' file defaults to the ``from'' file name if it isn't specified. The remote host executes the command string ``cat 'from';echo ^A'' to send the file to `tip`.
`~|`
  Pipe the output from a remote command to a local UNIX process. The command string sent to the local UNIX system is processed by the shell.
`~$`
  Pipe the output from a local UNIX process to the remote host. The command string sent to the local UNIX system is processed by the shell.
`~C`
  Fork a child process on the local system to perform special protocols such as XMODEM. The child program will be run with the following arrangement of file descriptors:

  0 | <-> | remote tty in
  1 | <-> | remote tty out
  2 | <-> | local tty out

`~+`
  Synonym for ~C, provided for compatibility with other versions of `cu`.
`~#`
  Send a `BREAK` to the remote system. For systems which don't support the necessary ioctl call the break is simulated by a sequence of line speed changes and `DEL` characters.
`~s`
  Set a variable (see the discussion below).
`~^Z`
  Stop `tip` (only available with job control).
`~^Y`
  Stop only the ``local side'' of `tip` (only available with job control); the ``remote side'' of `tip`, the side that displays output from the remote host, is left running.
`~?`
  Get a summary of the tilde escapes

`tip` uses the file /etc/remote to find how to reach a particular system and to find out how it should operate while talking to the system; refer to remote(5) for a full description. Each system has a default baud rate with which to establish a connection. If this value is not suitable, the baud rate to be used may be specified on the command line, e.g. ‘`tip -300 mds`’.

When `tip` establishes a connection it sends out a connection message to the remote system; the default value, if any, is defined in /etc/remote (see remote(5)).

When `tip` prompts for an argument (e.g. during setup of a file transfer) the line typed may be edited with the standard erase and kill characters. A null line in response to a prompt, or an interrupt, will abort the dialogue and return you to the remote machine.

`tip` guards against multiple users connecting to a remote system by opening modems and terminal lines with exclusive access, and by honoring the locking protocol used by uucico(8).

During file transfers `tip` provides a running count of the number of lines transferred. When using the ~> and ~< commands, the ``eofread'' and ``eofwrite'' variables are used to recognize end-of-file when reading, and specify end-of-file when writing (see below). File transfers normally depend on tandem mode for flow control. If the remote system does not support tandem mode, ``echocheck'' may be set to indicate `tip` should synchronize with the remote system on the echo of each transmitted character.

When `tip` must dial a phone number to connect to a system it will print various messages indicating its actions. `tip` supports the DEC DN-11 and Racal-Vadic 831 auto-call-units; the DEC DF02 and DF03, Ventel 212+, Racal-Vadic 3451, and Bizcomp 1031 and 1032 integral call unit/modems.

## VARIABLES

`tip` maintains a set of variables which control its operation. Some of these variables are read-only to normal users (root is allowed to change anything of interest). Variables may be displayed and set through the ``s'' escape. The syntax for variables is patterned after vi(1) and Mail(1). Supplying ``all'' as an argument to the set command displays all variables readable by the user. Alternatively, the user may request display of a particular variable by attaching a `?' to the end. For example ``escape?'' displays the current escape character.

Variables are numeric, string, character, or boolean values. Boolean variables are set merely by specifying their name; they may be reset by prepending a `!' to the name. Other variable types are set by concatenating an `=' and the value. The entire assignment must not have any blanks in it. A single set command may be used to interrogate as well as set a number of variables. Variables may be initialized at run time by placing set commands (without the ``~s'' prefix in a file .tiprc in one's home directory). The `-v` option causes `tip` to display the sets as they are made. Certain common variables have abbreviations. The following is a list of common variables, their abbreviations, and their default values.

beautify
  (bool) Discard unprintable characters when a session is being scripted; abbreviated be.
baudrate
  (num) The baud rate at which the connection was established; abbreviated ba.
dialtimeout
  (num) When dialing a phone number, the time (in seconds) to wait for a connection to be established; abbreviated dial.
echocheck
  (bool) Synchronize with the remote host during file transfer by waiting for the echo of the last character transmitted; default is off.
eofread
  (str) The set of characters which signify an end-of-transmission during a ~< file transfer command; abbreviated eofr.
eofwrite
  (str) The string sent to indicate end-of-transmission during a ~> file transfer command; abbreviated eofw.
eol
  (str) The set of characters which indicate an end-of-line. `tip` will recognize escape characters only after an end-of-line.
escape
  (char) The command prefix (escape) character; abbreviated es; default value is `~'.
exceptions
  (str) The set of characters which should not be discarded due to the beautification switch; abbreviated ex; default value is ``\t\n\f\b''.
force
  (char) The character used to force literal data transmission; abbreviated fo; default value is `^P'.
framesize
  (num) The amount of data (in bytes) to buffer between file system writes when receiving files; abbreviated fr.
host
  (str) The name of the host to which you are connected; abbreviated ho.
prompt
  (char) The character which indicates an end-of-line on the remote host; abbreviated pr; default value is `\n'. This value is used to synchronize during data transfers. The count of lines transferred during a file transfer command is based on receipt of this character.
raise
  (bool) Upper case mapping mode; abbreviated ra; default value is off. When this mode is enabled, all lower case letters will be mapped to upper case by `tip` for transmission to the remote machine.
raisechar
  (char) The input character used to toggle upper case mapping mode; abbreviated rc; default value is `^A'.
record
  (str) The name of the file in which a session script is recorded; abbreviated rec; default value is ``tip.record''.
script
  (bool) Session scripting mode; abbreviated sc; default is off. When script is `true`, `tip` will record everything transmitted by the remote machine in the script record file specified in record. If the beautify switch is on, only printable ASCII characters will be included in the script file (those characters between 040 and 0177). The variable exceptions is used to indicate characters which are an exception to the normal beautification rules.
tabexpand
  (bool) Expand tabs to spaces during file transfers; abbreviated tab; default value is false. Each tab is expanded to 8 spaces.
tandem
  (bool) Use XON/XOFF flow control to throttle data from the remote host; abbreviated ta. The default value is true unless the nt capability has been specified in /etc/remote, in which case the default value is false.
verbose
  (bool) Verbose mode; abbreviated verb; default is true. When verbose mode is enabled, `tip` prints messages while dialing, shows the current number of lines transferred during a file transfer operations, and more.

# ENVIRONMENT

`tip` uses the following environment variables:

`SHELL`
  (str) The name of the shell to use for the ~! command; default value is ``/bin/sh'', or taken from the environment.
`HOME`
  (str) The home directory to use for the ~c command; default value is taken from the environment.
`HOST`
  Check for a default host if none specified.

The variables `${REMOTE}` and `${PHONES}` are also exported.

# FILES

/etc/remote
  Global system descriptions.
/etc/phones
  Global phone number data base.
${REMOTE}
  Private system descriptions.
${PHONES}
  Private phone numbers.
~/.tiprc
  Initialization file.
tip.record
  Record file.

# DIAGNOSTICS

Diagnostics are, hopefully, self explanatory.

# SEE ALSO

phones(5), remote(5)

# HISTORY

The `tip` command appeared in 4.2BSD.

# BUGS

The full set of variables is undocumented and should, probably, be pared down.

November 29, 2006 | NetBSD 9.0